# -- coding: utf-8 --

# efektiivne lahendus sorteerimise ja kahendotsingutega
# O(N*log(N) + M*log(N)) - sorteerimine + korduvad kahendotsingud

import sys
from bisect import bisect_left

n = int(sys.stdin.readline().strip())
aa = [int(a) for a in sys.stdin.readline().split()]
aa.sort()

m = int(sys.stdin.readline().strip())
qq = [int(q) for q in sys.stdin.readline().split()]

for q in qq:
	# selline p, et aa[p - 1] < q <= aa[p]
	p = bisect_left(aa, q)
	if p == 0:
		best = aa[0]
	elif p == len(aa):
		best = aa[-1]
	elif q - aa[p - 1] <= aa[p] - q:
		best = aa[p - 1]
	else:
		best = aa[p]
	sys.stdout.write("{}\n".format(best))
